unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type
  {myThread}

  TMyThread = class(TThread)
   private

   protected
     procedure Execute; override;
   public
     Constructor Create(CreateSuspended : boolean);
   end;

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
  private
    { private declarations }
  public
    { public declarations }
    aThread: Array of TMyThread;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  setlength(aThread, length(aThread)+1);
  aThread[length(aThread)-1]:=TMyThread.Create(True);
  aThread[length(aThread)-1].Start;
  Label2.Caption:=IntToStr(length(aThread));
end;

procedure TForm1.Button2Click(Sender: TObject);
var i:Integer;
begin
  for i:=high(aThread) downto low(aThread) do
  begin
    aThread[i].Terminate;
  end;
  setlength(aThread, 0);
  Label2.Caption:=IntToStr(length(aThread));
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if length(aThread)>0 then
  begin
    Button2.Click;
  end;
  CanClose:=True;
end;

constructor TMyThread.Create(CreateSuspended : boolean);
begin
  FreeOnTerminate := True;
  inherited Create(CreateSuspended);
end;

procedure TMyThread.Execute;
var
  i:Integer;
  f:Real;
begin
  while (not Terminated) do
    begin
      i:=2563*256;
      i:=i;
      f:=25/98;
      f:=f;
    end;
end;

end.


